const app = getApp();
let self = null;

Page({
  data: {
		tabArr: ['全部','参团中','已团中','未团中'],
		currentTabIndex: 0,
		isLogin: false,
		list: null,
		isLoading: false, // 检测是否已经发送请求,防止重复发送请求
		noMore: false, // 检测是否有更多数据,true为没有更多数据,false为还有数据
		pageNum: 1, // 当前页数
		max_sw_height: 0,
  },
	
  onLoad: function (options) {
		self = this;
		      //群id
          if(options && options.groupchat_id){
            getApp().globalData.groupchat_id=options.groupchat_id
          }
		var first_leader = options.first_leader;
		if(first_leader) {
			app.globalData.first_leader = first_leader;
			//调用接口判断是不是会员
			app.request.promiseGet("/api/weshop/shoppingGuide/get/" + app.globalData.setting.stoid + "/" + first_leader, {}).then(res => {
					if (res.data.code == 0) {
						getApp().globalData.guide_id = res.data.data.id;
						getApp().globalData.guide_pick_id= res.data.data.pickup_id
					}
			})
		};
		
		// app.isLogin().then(function(data) {
		// 	self.setData({
		// 		userInfo: data,
		// 	});
		// });
  },
	
  onShow: function() {
      getApp().check_can_share(this);
		// if(app.globalData.userInfo) {
		// 	if(!this.data.isLogin) {

	            var user=app.globalData.userInfo;
				this.setData({
					userInfo:user ,
					imghost: app.globalData.setting.imghost,
					isLogin: true,
				});
				
				// 获取广告
				app.request.promiseGet("/api/weshop/ad/page", {
				  data: {
				    pid: 1204,
				    store_id: app.globalData.setting.stoid, 
				    enabled: 1
				  }
				}).then(res => {
					if(res.data.code == 0) {
						self.setData({
							adList: res.data.data.pageData,
						});
					};
				});
				
				// 获取列表
				self.getData(true, '/api/weshop/prom/luckyActivity/page', {
					store_id: app.globalData.setting.stoid,
					is_end: 0,
          timetype: 1,
          user_id: user ? user.user_id : '0'
				});
		
				
		// 	};
		// };
  },
	
	
	/**
	 * 生命周期函数--监听页面隐藏
	 */
	onHide: function () {
		this.data.isLogin = false;
	},
	
	/**
	 * 生命周期函数--监听页面卸载
	 */
	onUnload: function () {

	},
	
	
	/**
	 * 页面上拉触底事件的处理函数
	 */
	onReachBottom: function () {
    let user = this.data.user
		this.scrollToLower('/api/weshop/prom/luckyActivity/page', {
			store_id: app.globalData.setting.stoid,
			is_end: 0,
      timetype: 1,
      user_id: user ? user.user_id : '0'
		});
	},
	
	
	//跳转
	go: function (e) {
	  var url = e.currentTarget.dataset.url;
	  getApp().goto(url);
	},
	
	
	// 图片异常时加载默认图片
	bind_bnerr: function (e) {
	  var _errImg = e.target.dataset.errorimg;
	  var val = e.target.dataset.val;
	  if(val!=undefined && val!=null && val!='null' ){
	    var _errObj = {};
	    _errObj[_errImg] = "/public/images/default_goods_image_240.gif";
	    this.setData(_errObj) //注意这里的赋值方式,只是将数据列表中的此项图片路径值替换掉 ;
	  }
	},
	
	
	
	/**
	 * 请求数据
	 */
	getData: function(isInit, url, data) {
		let p = app.request.promiseGet(url, {
			data: data,
			isShowLoading: true,
		})
		.then(function(res) {
			if(res.data.code == 0) {
				
				self.setData({
					isLoading: false
				});
				
				if(isInit) {// 第一次加载
					self.setData({
						list: res.data.data
					});
				} else {
					self.setData({
						'list.pageData': self.data.list.pageData.concat(res.data.data.pageData)
					});
				};
				
				if((res.data.data.pageData.length == 0) || (res.data.data.pageSize * res.data.data.page >= res.data.data.total)) {
					self.setData({
						noMore: true
					});
				};
				
			} else {
				self.setData({
					'list.pageData': []
				});
			};
			
		});
	
		return p;
	},
	
	
	/**
	 * 上拉加载
	 */
	scrollToLower(url, requestData) {
		// 数据总量
		let total = this.data.list.total;
		// 单页最大数据量
		let pageSize = this.data.list.pageSize;
		// 如果数据总量不为0且小于或等于单页最大数据量，说明数据已全部加载，显示‘没有更多了’
		if((total != 0)&&(total <= pageSize)) {
			this.setData({
				noMore: true
			});
		};
		
		if(!this.data.isLoading && !this.data.noMore) {
			this.setData({
				isLoading: true,
				pageNum: this.data.pageNum + 1
			});
			requestData.page = this.data.pageNum;
			this.getData(false, url, requestData);
		};
	},
	
	
	/**
	 * 用户点击右上角分享
	 */
	onShareAppMessage: function (e) {
        getApp().globalData.no_clear=1
	    var pagePath = this.route; //当前页面url
	    if (pagePath.indexOf('/') != 0) {
	        pagePath = '/' + pagePath;
	    }
	    if(getApp().globalData.user_id){
	
	        if(pagePath.indexOf("?")>0){
	            pagePath+="&first_leader="+getApp().globalData.user_id;
	        }else{
	            pagePath+="?first_leader="+getApp().globalData.user_id;
	        }
          //群id分享
          if (getApp().globalData.groupchat_id) {
            pagePath+="&groupchat_id="+getApp().globalData.groupchat_id
          }
      }else{
        if(pagePath.indexOf("?")>0){
          pagePath+="&groupchat_id="+getApp().globalData.groupchat_id
        }else{
          pagePath+="?groupchat_id="+getApp().globalData.groupchat_id
        }

      }
	    return {
	        title: "幸运购活动列表",
	        path: pagePath,
	    }
	},
	
	// onShareTimeline() {
	// 	var store_name = getApp().globalData.config ? getApp().globalData.config.store_name:'';
	// 	var pagePath = this.route; //当前页面url
		
	// 	if(!store_name) store_name = getApp().globalData.setting.appName;
	// 	if (pagePath.indexOf('/') != 0) {
	// 	  pagePath = '/' + pagePath;
	// 	}
	// 	return {
	// 	  title: store_name + '-幸运购活动列表',
	// 	  path: pagePath,
	// 	}
	// },
	
	imageLoad: function (e) {
	  var imgwidth = e.detail.width;
	  var imgheight = e.detail.height;
	  //宽高比
	  var ratio = imgwidth / imgheight;
	  //计算的高度值
	  var viewHeight = 715 / ratio;
	  if (this.data.max_sw_height < viewHeight) this.setData({
	    max_sw_height: viewHeight
	  });
	},
	
})

